/* ***********************************************************
 * This file was automatically generated on 2013-11-27.      *
 *                                                           *
 * Bindings Version 2.0.12                                    *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Device with two buttons and two LEDs
	/// </summary>
	public class BrickletDualButton : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>
		/// </summary>
		public static int DEVICE_IDENTIFIER = 230;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletDualButton.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletDualButton.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletDualButton.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_LED_STATE = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletDualButton.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletDualButton.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletDualButton.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_LED_STATE = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletDualButton.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletDualButton.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletDualButton.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_BUTTON_STATE = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletDualButton.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletDualButton.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletDualButton.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte CALLBACK_STATE_CHANGED = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletDualButton.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletDualButton.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletDualButton.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_SELECTED_LED_STATE = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletDualButton.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletDualButton.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletDualButton.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;


		/// <summary>
		/// </summary>
		public const byte LED_STATE_AUTO_TOGGLE_ON = 0;

		/// <summary>
		/// </summary>
		public const byte LED_STATE_AUTO_TOGGLE_OFF = 1;

		/// <summary>
		/// </summary>
		public const byte LED_STATE_ON = 2;

		/// <summary>
		/// </summary>
		public const byte LED_STATE_OFF = 3;

		/// <summary>
		/// </summary>
		public const byte BUTTON_STATE_PRESSED = 0;

		/// <summary>
		/// </summary>
		public const byte BUTTON_STATE_RELEASED = 1;

		/// <summary>
		/// </summary>
		public const byte LED_LEFT = 0;

		/// <summary>
		/// </summary>
		public const byte LED_RIGHT = 1;


		/// <summary>
		///  This callback is called whenever a button is pressed. 
		///  
		///  Possible states for buttons are:
		///  
		///  * 0 = pressed
		///  * 1 = released
		///  
		///  Possible states for LEDs are:
		///  
		///  * 0 = AutoToggleOn: Auto toggle enabled and LED on.
		///  * 1 = AutoToggleOff: Auto toggle enabled and LED off.
		///  * 2 = On: LED on (auto toggle is disabled).
		///  * 3 = Off: LED off (auto toggle is disabled).
		/// </summary>
		public event StateChangedEventHandler StateChanged;
		/// <summary>
		/// </summary>
		public delegate void StateChangedEventHandler(BrickletDualButton sender, byte buttonL, byte buttonR, byte ledL, byte ledR);

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletDualButton(string uid, IPConnection ipcon) : base(uid, ipcon)
		{
			this.apiVersion[0] = 2;
			this.apiVersion[1] = 0;
			this.apiVersion[2] = 0;
			callbackWrappers[CALLBACK_STATE_CHANGED] = new CallbackWrapper(OnStateChanged);

			responseExpected[FUNCTION_SET_LED_STATE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_LED_STATE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_BUTTON_STATE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_SELECTED_LED_STATE] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[CALLBACK_STATE_CHANGED] = ResponseExpectedFlag.ALWAYS_FALSE;
		}

		/// <summary>
		///  Sets the state of the LEDs. Possible states are:
		///  
		///  * 0 = AutoToggleOn: Enables auto toggle with initially enabled LED.
		///  * 1 = AutoToggleOff: Activates auto toggle with initially disabled LED.
		///  * 2 = On: Enables LED (auto toggle is disabled).
		///  * 3 = Off: Disables LED (auto toggle is disabled).
		///  
		///  In auto toggle mode the LED is toggled automatically at each press of a button.
		///  
		///  If you just want to set one of the LEDs and don't know the current state
		///  of the other LED, you can get the state with <see cref="Tinkerforge.BrickletDualButton.GetLEDState"/> or you
		///  can use <see cref="Tinkerforge.BrickletDualButton.SetSelectedLEDState"/>.
		///  
		///  The default value is (1, 1).
		/// </summary>
		public void SetLEDState(byte ledL, byte ledR)
		{
			byte[] request = CreateRequestPacket(10, FUNCTION_SET_LED_STATE);
			LEConverter.To((byte)ledL, 8, request);
			LEConverter.To((byte)ledR, 9, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the current state of the LEDs, as set by <see cref="Tinkerforge.BrickletDualButton.SetLEDState"/>.
		/// </summary>
		public void GetLEDState(out byte ledL, out byte ledR)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_LED_STATE);

			byte[] response = SendRequest(request);

			ledL = LEConverter.ByteFrom(8, response);
			ledR = LEConverter.ByteFrom(9, response);
		}

		/// <summary>
		///  Returns the current state for both buttons. Possible states are:
		///  
		///  * 0 = pressed
		///  * 1 = released
		/// </summary>
		public void GetButtonState(out byte buttonL, out byte buttonR)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_BUTTON_STATE);

			byte[] response = SendRequest(request);

			buttonL = LEConverter.ByteFrom(8, response);
			buttonR = LEConverter.ByteFrom(9, response);
		}

		/// <summary>
		///  Sets the state of the selected LED (0 or 1). 
		///  
		///  The other LED remains untouched.
		///  
		///  .. versionadded:: 2.0.0~(Plugin)
		/// </summary>
		public void SetSelectedLEDState(byte led, byte state)
		{
			byte[] request = CreateRequestPacket(10, FUNCTION_SET_SELECTED_LED_STATE);
			LEConverter.To((byte)led, 8, request);
			LEConverter.To((byte)state, 9, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to, 
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c' or 'd'.
		///  
		///  The device identifiers can be found :ref:`here &lt;device_identifier&gt;`.
		///  
		///  .. versionadded:: 2.0.0~(Plugin)
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnStateChanged(byte[] response)
		{
			byte buttonL = LEConverter.ByteFrom(8, response);
			byte buttonR = LEConverter.ByteFrom(9, response);
			byte ledL = LEConverter.ByteFrom(10, response);
			byte ledR = LEConverter.ByteFrom(11, response);

			var handler = StateChanged;
			if(handler != null)
			{
				handler(this, buttonL, buttonR, ledL, ledR);
			}
		}
	}
}