/* ***********************************************************
 * This file was automatically generated on 2013-11-27.      *
 *                                                           *
 * Bindings Version 2.0.12                                    *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generator git on tinkerforge.com                   *
 *************************************************************/

using System;

namespace Tinkerforge
{
	/// <summary>
	///  Device that controls mains switches remotely
	/// </summary>
	public class BrickletRemoteSwitch : Device
	{
		/// <summary>
		///  Used to identify this device type in
		///  <see cref="Tinkerforge.IPConnection.EnumerateCallback"/>
		/// </summary>
		public static int DEVICE_IDENTIFIER = 235;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletRemoteSwitch.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletRemoteSwitch.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletRemoteSwitch.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SWITCH_SOCKET = 1;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletRemoteSwitch.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletRemoteSwitch.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletRemoteSwitch.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_SWITCHING_STATE = 2;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletRemoteSwitch.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletRemoteSwitch.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletRemoteSwitch.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte CALLBACK_SWITCHING_DONE = 3;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletRemoteSwitch.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletRemoteSwitch.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletRemoteSwitch.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_SET_REPEATS = 4;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletRemoteSwitch.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletRemoteSwitch.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletRemoteSwitch.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_REPEATS = 5;

		/// <summary>
		///  Function ID to be used with
		///  <see cref="Tinkerforge.BrickletRemoteSwitch.GetResponseExpected"/>,
		///  <see cref="Tinkerforge.BrickletRemoteSwitch.SetResponseExpected"/> and
		///  <see cref="Tinkerforge.BrickletRemoteSwitch.SetResponseExpectedAll"/>.
		/// </summary>
		public const byte FUNCTION_GET_IDENTITY = 255;


		/// <summary>
		/// </summary>
		public const byte SWITCH_TO_OFF = 0;

		/// <summary>
		/// </summary>
		public const byte SWITCH_TO_ON = 1;

		/// <summary>
		/// </summary>
		public const byte SWITCHING_STATE_READY = 0;

		/// <summary>
		/// </summary>
		public const byte SWITCHING_STATE_BUSY = 1;


		/// <summary>
		///  This callback is called whenever the switching state changes
		///  from busy to ready, see <see cref="Tinkerforge.BrickletRemoteSwitch.GetSwitchingState"/>.
		/// </summary>
		public event SwitchingDoneEventHandler SwitchingDone;
		/// <summary>
		/// </summary>
		public delegate void SwitchingDoneEventHandler(BrickletRemoteSwitch sender);

		/// <summary>
		///  Creates an object with the unique device ID <c>uid</c> and adds  it to
		///  the IPConnection <c>ipcon</c>.
		/// </summary>
		public BrickletRemoteSwitch(string uid, IPConnection ipcon) : base(uid, ipcon)
		{
			this.apiVersion[0] = 2;
			this.apiVersion[1] = 0;
			this.apiVersion[2] = 0;
			callbackWrappers[CALLBACK_SWITCHING_DONE] = new CallbackWrapper(OnSwitchingDone);

			responseExpected[FUNCTION_SWITCH_SOCKET] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_SWITCHING_STATE] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_SET_REPEATS] = ResponseExpectedFlag.FALSE;
			responseExpected[FUNCTION_GET_REPEATS] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[FUNCTION_GET_IDENTITY] = ResponseExpectedFlag.ALWAYS_TRUE;
			responseExpected[CALLBACK_SWITCHING_DONE] = ResponseExpectedFlag.ALWAYS_FALSE;
		}

		/// <summary>
		///  To switch a socket you have to give the house code, receiver code and the
		///  state (on or off) you want to switch to.
		///  
		///  A detailed description on how you can find the house and receiver code
		///  can be found :ref:`here &lt;remote_switch_bricklet_house_and_receiver_code&gt;`.
		/// </summary>
		public void SwitchSocket(byte houseCode, byte receiverCode, byte switchTo)
		{
			byte[] request = CreateRequestPacket(11, FUNCTION_SWITCH_SOCKET);
			LEConverter.To((byte)houseCode, 8, request);
			LEConverter.To((byte)receiverCode, 9, request);
			LEConverter.To((byte)switchTo, 10, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the current switching state. If the current state is busy, the
		///  Bricklet is currently sending a code to switch a socket. It will not
		///  accept any calls of <see cref="Tinkerforge.BrickletRemoteSwitch.SwitchSocket"/> until the state changes to ready.
		///  
		///  How long the switching takes is dependent on the number of repeats, see
		///  <see cref="Tinkerforge.BrickletRemoteSwitch.SetRepeats"/>.
		/// </summary>
		public byte GetSwitchingState()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_SWITCHING_STATE);

			byte[] response = SendRequest(request);

			return LEConverter.ByteFrom(8, response);
		}

		/// <summary>
		///  Sets the number of times the code is send when <see cref="Tinkerforge.BrickletRemoteSwitch.SwitchSocket"/> is called.
		///  The repeats basically correspond to the amount of time that a button of the
		///  remote is pressed. 
		///  
		///  Some dimmers are controlled by the length of a button pressed,
		///  this can be simulated by increasing the repeats.
		///  
		///  The default value is 5.
		/// </summary>
		public void SetRepeats(byte repeats)
		{
			byte[] request = CreateRequestPacket(9, FUNCTION_SET_REPEATS);
			LEConverter.To((byte)repeats, 8, request);

			SendRequest(request);

		}

		/// <summary>
		///  Returns the number of repeats as set by <see cref="Tinkerforge.BrickletRemoteSwitch.SetRepeats"/>.
		/// </summary>
		public byte GetRepeats()
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_REPEATS);

			byte[] response = SendRequest(request);

			return LEConverter.ByteFrom(8, response);
		}

		/// <summary>
		///  Returns the UID, the UID where the Bricklet is connected to, 
		///  the position, the hardware and firmware version as well as the
		///  device identifier.
		///  
		///  The position can be 'a', 'b', 'c' or 'd'.
		///  
		///  The device identifiers can be found :ref:`here &lt;device_identifier&gt;`.
		///  
		///  .. versionadded:: 2.0.0~(Plugin)
		/// </summary>
		public override void GetIdentity(out string uid, out string connectedUid, out char position, out byte[] hardwareVersion, out byte[] firmwareVersion, out int deviceIdentifier)
		{
			byte[] request = CreateRequestPacket(8, FUNCTION_GET_IDENTITY);

			byte[] response = SendRequest(request);

			uid = LEConverter.StringFrom(8, response, 8);
			connectedUid = LEConverter.StringFrom(16, response, 8);
			position = LEConverter.CharFrom(24, response);
			hardwareVersion = LEConverter.ByteArrayFrom(25, response, 3);
			firmwareVersion = LEConverter.ByteArrayFrom(28, response, 3);
			deviceIdentifier = LEConverter.UShortFrom(31, response);
		}

		/// <summary>
		/// </summary>
		protected void OnSwitchingDone(byte[] response)
		{
			var handler = SwitchingDone;
			if(handler != null)
			{
				handler(this);
			}
		}
	}
}